Sample_paired <- function(data,L,starting,
                          muBH,muBL,muHyper,muHypo,
                          cBHX,cBLX,cBHY,cBLY,
                          sigmaHyper,sigmaHypo,
                          burnin = 8000, iter = 10000,
                          seed = 0912, alpha = 0.9, limitpmv = 0.99,
                          D = 0.3, D2 = 0.10){
  # Variables
  StartProb = array(0,c(nStates,iter+1)) 
  dimnames(StartProb) = list(state=HMM$States, i=0:iter)
  mu.BH = mu.BL = array(0,iter+1)
  mu.Hyper = mu.Hypo = array(0,c(2,iter+1))
  c.BHX = c.BLX = c.BHY = c.BLY = array(0,iter+1)
  sigma.Hyper = sigma.Hypo = array(0,c(2,2,iter+1))
  e = array(0,c(nStates,iter+1)) 
  dimnames(e) = list(state=HMM$States, i=0:iter)
  pX = array(0,c(T,iter-burnin)) 
  dimnames(pX) = list(t=1:T, i=(burnin+1):iter)
  pY = array(0,c(T,iter-burnin)) 
  dimnames(pY) = list(t=1:T, i=(burnin+1):iter)
  states = array(0,c(T,iter-burnin))
  dimnames(states) = list(t=1:T, i=(burnin+1):iter)
  bw = array(NA, c(nStates, T))
  dimnames(bw) = list(states = HMM$States, index = 1:T)
  
  
  
  for ( i in 1:iter){
    tempHMM = list(Iteration=i, States=HMM$States, 
                   StartProb=StartProb[,i], e = e[,i], 
                   muBH=mu.BH[i], muBL=mu.BL[i], muHyper=mu.Hyper[,i], muHypo=mu.Hypo[,i],
                   cBHX=c.BHX[i], cBLX=c.BLX[i], 
                   cBHY=c.BHY[i], cBLY=c.BLY[i],
                   sigmaHyper=sigma.Hyper[,,i], sigmaHypo=sigma.Hypo[,,i])
    names(tempHMM$e) = HMM$States
  }
}