% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/InitialValues.R
\name{InitialValues}
\alias{InitialValues}
\title{Generate and encapsulate initial values}
\usage{
InitialValues(States = c("Both High", "Both Low", "HyperM", "HypoM"),
  isp = NULL, ie = NULL, imuBH = NULL, imuBL = NULL,
  icBHX = NULL, icBLX = NULL, icBHY = NULL, icBLY = NULL,
  D = 0.3, imuHyper1 = NULL, imuHypo1 = NULL, s113 = NULL,
  s223 = NULL, rho3 = NULL, s114 = NULL, s224 = NULL,
  rho4 = NULL, alpha = 0.8)
}
\arguments{
\item{States}{Length-4 vector representing the four methylation states}

\item{isp}{Length-4 vector representing the initial state distribution}

\item{ie}{Length-4 vector, the parameter in the transition model, the logarithm of the characteristic lengths.}

\item{imuBH}{the mean of the underlying methylation proportion for the 'Both High' loci}

\item{imuBL}{the mean of the underlying methylation proportion for the 'Both Low' loci}

\item{icBHX}{variance of \eqn{pX_{ij}} in the 'Both High' regions}

\item{icBLX}{variance of \eqn{pX_{ij}} in the 'Both Low' regions}

\item{icBHY}{variance of \eqn{pY_{ij}} in the 'Both High' regions}

\item{icBLY}{variance of \eqn{py_{ij}} in the 'Both Low' regions}

\item{D}{tunning parameter in model, 
which represent the minimun difference between the mean of \eqn{pX_{ij}} and \eqn{pY_{ij}} in the DMR regions}

\item{imuHyper1}{the mean of \eqn{logit(pX_{ij})} for the 'HyperM' loci}

\item{imuHypo1}{the mean of \eqn{logit(pX_{ij})} for  the 'HypoM' loci}

\item{s113}{variance of \eqn{logit(pX_{ij})} in the 'HyperM' regions}

\item{s223}{variance of \eqn{logit(pY_{ij})} in the 'HyperM' regions}

\item{rho3}{Correlation of \eqn{logit(pX_{ij})} and \eqn{logit(pY_{ij})} for the 'HyperM' loci}

\item{s114}{variance of \eqn{logit(pX_{ij})} in the 'HypoM' regions}

\item{s224}{variance of \eqn{logit(pY_{ij})} in the 'HypoM' regions}

\item{rho4}{Correlation of \eqn{logit(pX_{ij})} and \eqn{logit(pY_{ij})} for the 'HypoM' loci}

\item{alpha}{tunning parameter in model, 
which used to truncating the covariant matrices of bivariate normals of DMC's responses.}
}
\value{
Simply a list with all information are the same with input, 
if the initial values of all parameters are entered, 
otherwise the initial values are generated randomly.
}
\description{
Generate and encapsulate initial values
}
