% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MergeData.R
\name{MergeData}
\alias{MergeData}
\title{Read WGBS data of tumour cell and normal cell loaded from GEO,
then reform them into a 2-by-7 data frame.}
\usage{
MergeData(TumourFile, NormalFile)
}
\arguments{
\item{TumourFile}{The name of the file containing the WGBS data 
of tumour cell to be read from.}

\item{NormalFile}{The name of the file containing the WGBS data 
of normal cell to be read from.}
}
\value{
A data frame with two rows and 7 columns. 
Rows represent tumour cell and normal cell in order.
And Columns represent chromosome 'chr', 
starting positions of CpG sites 'starting',
the ending positions of CpG sites 'ending', 
the numbers of methylated 
cytosine reads and read depths from tumour cell \eqn{X,nX}, 
the numbers of methylated 
cytosine reads and read depths from normal cell \eqn{Y,nY}
}
\description{
Read WGBS data of tumour cell and normal cell loaded from GEO,
then reform them into a 2-by-7 data frame.
}
