% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SampleStates.R
\name{SampleStates}
\alias{SampleStates}
\title{The forwar-backward Gibbs sampler to sample the hidden states.}
\usage{
SampleStates(HMM, emp, bw, L, ending = NULL)
}
\arguments{
\item{HMM}{list of the informations of the HMM including states,
startprob and the mean and variance at each states.}

\item{emp}{4-by-N matrix of log prob of observation and underlying prob for the i-th CpG site, 
given the state and parameters of the model:}

\item{bw}{4-by-N matrix of log prob of observation and underlying prob after the i-th CpG site, 
given the state and parameters of the model:}

\item{L}{vector of the distance between neighboouring sites}

\item{ending}{vector of ending positions of each chains}
}
\value{
list contains:
\item{States}{Length-T vector of hidden states}
\item{PostProb}{Length-T vector representing the 
logarithm of the joint probabilities of state,observation and underlying probability}
}
\description{
The forwar-backward Gibbs sampler to sample the hidden states.
}
