% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SampleUnderProb.R
\name{SampleUnderProb}
\alias{SampleUnderProb}
\title{Given \eqn{\Theta^{(t)}} and the Updated state, 
sample the underlying probability pX and pY.}
\usage{
SampleUnderProb(HMM, data, states.i, pX.i, pY.i, adspXi, adspYi)
}
\arguments{
\item{HMM}{list of the informations of the HMM 
including states, startprob and the mean and variance 
at each states.}

\item{data}{Integrated data, including all the information from WGBS data used in the estimation .}

\item{states.i}{Length-N vector representing the hidden states.}

\item{pX.i}{Length-N vector representing the underlying prob of X.}

\item{pY.i}{Length-N vector representing the underlying prob of Y.}

\item{adspXi}{Sd of the proposal density of pX}

\item{adspYi}{Sd of the proposal density of pY}
}
\value{
A list containing
\item{pX.i}{Updated pX.i}
\item{pY.i}{Updated pY.i}
\item{index.i1}{the index of the CpG sites in each state.}
\item{COUNTS}{the number of CpG sites in each state.}
}
\description{
Given \eqn{\Theta^{(t)}} and the Updated state, 
sample the underlying probability pX and pY.
}
\examples{
  
}
