% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/update_DMR.r
\name{Update_DMR}
\alias{Update_DMR}
\title{Update parameters of DMCs}
\usage{
Update_DMR(NinDMR, lpX, lpY, mu, sigma, mu0, sigma0, sstemp, shape11,
  shape22, State, J, D, alpha)
}
\arguments{
\item{NinDMR}{number of CpG sites in 'Hyper'('Hypo') status}

\item{lpX}{a numeric vector of the logit-transformed methylation levels of 
CpG sites in 'Hyper'('Hypo') status from the control groups.}

\item{lpY}{a numeric vector of the logit-transformed methylation levels of 
CpG sites in 'Hyper'('Hypo') status from the case groups.}

\item{mu}{mean from the previous iteration.}

\item{sigma}{covariance matrix from the previous iteration.}

\item{mu0}{vector of means of \eqn{mu_k}'s prior for \eqn{k=3,4}.}

\item{sigma0}{Covariance matrix of \eqn{mu_k}'s prior}

\item{sstemp}{standard deviation of \eqn{rho_{Xk}}'s proposal}

\item{shape11}{the shape parameter 
of \eqn{sigma_{1k}}'s proposal for \eqn{k=3,4}.}

\item{shape22}{the shape parameter 
of \eqn{sigma_{2k}}'s proposal for \eqn{k=3,4}.}

\item{State}{'HyperM' or 'HypoM'}

\item{J}{number of pairs}

\item{D}{tunning parameter in model, 
which represent the minimun difference between the mean of \eqn{pX_{ij}} and \eqn{pY_{ij}} in the DMR regions.}

\item{alpha}{tunning parameter in model, 
which used to truncating the covariant matrices of bivariate normals of DMC's responses.}
}
\value{
A list containing
\item{mu_updated}{Updated mean of the logit-transformed methylation levels}
\item{sigma_updated}{Updated covariance matrixof the logit-transformed methylation levels}
}
\description{
Updata the mean \eqn{mu_k} and covariance matrix \eqn{sigma_{Xk}}
of methylation levels of DMCs('HyperM' or 'HypoM) for \eqn{k=3,4}
}
