% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/call_DMCs.R
\name{call_DMCs}
\alias{call_DMCs}
\title{Sample state and underlying prob given the parameter in the NHMM model}
\usage{
call_DMCs(data, ending = NULL, init, burnin = 80, iter = 100,
  seed = 912, pX.i0 = NULL, pY.i0 = NULL, nadjust = 2000, filename,
  adjust = TRUE)
}
\arguments{
\item{data}{Integrated data, including all the information from WGBS data used in sampler .}

\item{ending}{ending of each chain. Default is NULL, 
and a new chain will be initialized when
distance larger than 10,000bp.}

\item{init}{list of initial values}

\item{burnin}{number of iterations for burn-in (including parameter adjustment). Default is 8000.}

\item{iter}{total number of iterations. Defaut is 10000}

\item{seed}{a single value, interpreted as an integer. Default is 912.}

\item{pX.i0}{vector representing the initial values of p_{X_{ij}}, default is NULL.}

\item{pY.i0}{vector representing the initial values of p_{Y_{ij}}, default is NULL.}

\item{nadjust}{number of iterations for parameter adjustment. Only works when adjust = TRUE. Default is 2000.}

\item{filename}{output file name}

\item{adjust}{logical; if TRUE(default), adjust parameters in proposal automatically.}
}
\value{
A list containing
\item{DMR.prob}{ probability of being DMR for each CpG site. }
\item{states}{MAP estimations of the status of each CpG site. 
1 to 4 represent 'Both High','Both Low','HyperM' and 'HypoM' respectively. }
\item{DMCs}{MAP estimations of the status of each CpG site. 
0 and 1 represent 'nonDMR' and 'DMR' respectively. }
}
\description{
Sample state and underlying prob given the parameter in the NHMM model
}
\examples{

}
