#include <Rcpp.h>
using namespace Rcpp;

// This is a simple example of exporting a C++ function to R. You can
// source this function into an R session using the Rcpp::sourceCpp 
// function (or via the Source button on the editor toolbar). Learn
// more about Rcpp at:
//
//   http://www.rcpp.org/
//   http://adv-r.had.co.nz/Rcpp.html
//   http://gallery.rcpp.org/
//

// [[Rcpp::export]]
double postprobc(List HMM, NumericMatrix emp, 
                 IntegerVector L,IntegerVector S, 
                 NumericVector start,NumericVector end) {
  int ncase = start.size();
  double j=0,a; int s;
  double* pemp = &emp(0,0);
  int* pL = &L(0);
  NumericVector SP(4),ee(4);
  ee = exp(as<NumericVector>(HMM["e"]));
  SP = log(as<NumericVector>(HMM["StartProb"]));
  for (int i=1; i<=ncase; i++,pL++) { 
    if ((ncase > 1) && (start[i-1] == start[i])) {continue;}
    s = S[start[i-1]-1]-1;
    j += SP[s] + *(pemp+s); pemp +=4;
    for (int t=start[i-1];t<=end[i-1]-1;t++,pemp+=4) {
      s = S[t-1]-1;
      a = 0.25 - 0.25*exp(-*pL++/ee[s]);
      if (s == S[t]-1 ) a = 1-a-a-a;
      j += log(a) + *(pemp+S[t]-1);
    }
  }
  return(j);
}


// You can include R code blocks in C++ files processed with sourceCpp
// (useful for testing and development). The R code will be automatically 
// run after the compilation.
//

