#include <Rcpp.h>
using namespace Rcpp;

// This is a simple example of exporting a C++ function to R. You can
// source this function into an R session using the Rcpp::sourceCpp 
// function (or via the Source button on the editor toolbar). Learn
// more about Rcpp at:
//
//   http://www.rcpp.org/
//   http://adv-r.had.co.nz/Rcpp.html
//   http://gallery.rcpp.org/
//

// [[Rcpp::export]]
IntegerVector SampleStatesc(List HMM, NumericMatrix emp, 
                            NumericMatrix bw, IntegerVector L,
                            NumericVector start, 
                            NumericVector end) {
  int ncase = start.size(), N = emp.ncol();
  NumericVector a(4),SP(4),
  e = as<NumericVector>(HMM["e"]),ee(4),temp(4);
  IntegerVector S(N);
  double* pemp = &emp(0,0);
  int* pL = &L(0); 
  double* pbw = &bw(0,0);
  double d,z,p,b;
  ee = exp(e);
  SP = log(as<NumericVector>(HMM["StartProb"]));
  for (int i=1; i<=ncase; i++,pL++) { 
    if ((ncase > 1) && (start[i-1] == start[i])) {continue;}
    temp(0) = SP[0] + *pemp++ + *pbw++;
    temp(1) = SP[1] + *pemp++ + *pbw++;
    temp(2) = SP[2] + *pemp++ + *pbw++;
    temp(3) = SP[3] + *pemp++ + *pbw++;
    d = temp(0);
    for ( int c=1; c<4; c++ ) { if ( d<temp(c) ) { d=temp(c); }  }
    a = exp(temp-d);z = log(a[0]+a[1]+a[2]+a[3])+d;
    temp = exp(temp-z);
    for (int j=1; j<4; j++) {temp[j]+=temp[j-1];}
    p = (double)rand()/RAND_MAX;
    if(p<=temp[0]){S[start[i-1]-1]=1;}else if(p<=temp[1]){S[start[i-1]-1]=2;
    }else if(p<=temp[2]){S[start[i-1]-1]=3;}else {S[start[i-1]-1]=4;}
    for (int t=start[i-1];t<=end[i-1]-1;t++) {
      switch(S[t-1]) {
      case 1:
        z = 0.25 - 0.25*exp(-*pL++/ee[0]); b = log(z);
        temp(0) = log(1-z-z-z) + *pemp++ + *pbw++;
        temp(1) = b + *pemp++ + *pbw++;
        temp(2) = b + *pemp++ + *pbw++;
        temp(3) = b + *pemp++ + *pbw++; 
        break;
      case 2:
        z = 0.25 - 0.25*exp(-*pL++/ee[1]); b = log(z);
        temp(0) = b + *pemp++ + *pbw++;
        temp(1) = log(1-z-z-z) + *pemp++ + *pbw++;
        temp(2) = b + *pemp++ + *pbw++;
        temp(3) = b + *pemp++ + *pbw++;
        break;
      case 3:
        z = 0.25 - 0.25*exp(-*pL++/ee[2]); b = log(z);
        temp(0) = b + *pemp++ + *pbw++;
        temp(1) = b + *pemp++ + *pbw++;
        temp(2) = log(1-z-z-z) + *pemp++ + *pbw++;
        temp(3) = b + *pemp++ + *pbw++;
        break;
      case 4:
        z = 0.25 - 0.25*exp(-*pL++/ee[3]); b = log(z);
        temp(0) = b + *pemp++ + *pbw++;
        temp(1) = b + *pemp++ + *pbw++;
        temp(2) = b + *pemp++ + *pbw++;
        temp(3) = log(1-z-z-z) + *pemp++ + *pbw++;
        break;
      default:
        Rprintf("Error!");
      }
      d = temp(0);
      for ( int c=1; c<4; c++ ) { if ( d<temp(c) ) { d=temp(c); }  }
      a = exp(temp-d);z = log(a[0]+a[1]+a[2]+a[3])+d;
      temp = exp(temp-z);
      for (int j=1; j<4; j++) {temp[j]+=temp[j-1];}
      p = (double)rand()/RAND_MAX;
      if(p<=temp[0]){S[t]=1;}else if(p<=temp[1]){S[t]=2;
      }else if(p<=temp[2]){S[t]=3;}else {S[t]=4;}
    }
  }
  return S;
}


// You can include R code blocks in C++ files processed with sourceCpp
// (useful for testing and development). The R code will be automatically 
// run after the compilation.
//
