#include <Rcpp.h>
using namespace Rcpp;

// This is a simple example of exporting a C++ function to R. You can
// source this function into an R session using the Rcpp::sourceCpp 
// function (or via the Source button on the editor toolbar). Learn
// more about Rcpp at:
//
//   http://www.rcpp.org/
//   http://adv-r.had.co.nz/Rcpp.html
//   http://gallery.rcpp.org/
//

// [[Rcpp::export]]
NumericMatrix backwardc(List HMM, NumericMatrix emp, IntegerVector L, 
                        NumericVector start, NumericVector end) {
  int ncase = start.size(), N = emp.ncol();
  NumericMatrix bw(emp.nrow(),N),temp(4,4);
  NumericVector e = as<NumericVector>(HMM["e"]),ee(4),a(4),b(4);
  double d;
  double* pemp = &emp(3,N-1);
  int* pL = &L(N-2); 
  double* pbw = &bw(3,N-1);
  Function logexpsum("logexpsum");
  ee = exp(e);
  for (int i=ncase; i>=1; i--,pbw-=4,pemp-=4,pL--) { 
    if ((ncase > 1) && (start[i-1] == start[i])) {continue;}
    for (int t=end[i-1]-1;t>=start[i-1];t--,pL--,pbw+=4) {
      a = 0.25 - 0.25*exp(-*pL/ee); 
      b = log(a); 
      temp(0,3) = b[0]+*(pbw)+*pemp;
      temp(1,3) = b[1]+*(pbw)+*pemp;
      temp(2,3) = b[2]+*(pbw)+*pemp;
      temp(3,3) = log(1-a[3]-a[3]-a[3])+*(pbw--)+*(pemp--);
      temp(0,2) = b[0]+*(pbw)+*pemp;
      temp(1,2) = b[1]+*(pbw)+*pemp;
      temp(2,2) = log(1-a[2]-a[2]-a[2])+*(pbw)+*pemp;
      temp(3,2) = b[3]+*(pbw--)+*(pemp--);
      temp(0,1) = b[0]+*(pbw)+*pemp;
      temp(1,1) = log(1-a[1]-a[1]-a[1])+*(pbw)+*pemp;
      temp(2,1) = b[2]+*(pbw)+*pemp;
      temp(3,1) = b[3]+*(pbw--)+*(pemp--);
      temp(0,0) = log(1-a[0]-a[0]-a[0])+*(pbw)+*pemp;
      temp(1,0) = b[1]+*(pbw)+*pemp;
      temp(2,0) = b[2]+*(pbw)+*pemp;
      temp(3,0) = b[3]+*(pbw--)+*(pemp--);
      d = temp(3,0);
      for ( int c = 1; c < 4; c++ ) {
        if ( d<temp(3,c) ) { d = temp(3,c); }  
      }
      a = exp(temp(3,_)-d);
      *(pbw--) = log(a[0]+a[1]+a[2]+a[3])+d;
      d = temp(2,0);
      for ( int c = 1; c < 4; c++ ) {
        if ( d<temp(2,c) ) { d = temp(2,c); }  
      }
      a = exp(temp(2,_)-d);
      *(pbw--) = log(a[0]+a[1]+a[2]+a[3])+d;
      d = temp(1,0);
      for ( int c = 1; c < 4; c++ ) {
        if ( temp(1,c)>d ) { d = temp(1,c); }  
      }
      a = exp(temp(1,_)-d);
      *(pbw--) = log(a[0]+a[1]+a[2]+a[3])+d;
      d = temp(0,0);
      for ( int c = 1; c < 4; c++ ) {
        if ( temp(0,c)>d ) { d = temp(0,c); }  
      }
      a = exp(temp(0,_)-d);
      *(pbw--) = log(a[0]+a[1]+a[2]+a[3])+d;
    }
  }
  return bw;
}


// You can include R code blocks in C++ files processed with sourceCpp
// (useful for testing and development). The R code will be automatically 
// run after the compilation.
//


